/* header auto-generated by pidl */

#ifndef _PIDL_HEADER_mapistore_mgmt
#define _PIDL_HEADER_mapistore_mgmt

#include <util/data_blob.h>
#include <stdint.h>

#include <core/ntstatus.h>

#ifndef _HEADER_mapistore_mgmt
#define _HEADER_mapistore_mgmt

enum mapistore_mgmt_command_priority
#ifndef USE_UINT_ENUMS
 {
	MAPISTORE_COMMAND_NOTIF_REGISTER_PRIO=(int)(26),
	MAPISTORE_COMMAND_NOTIF_UNREGISTER_PRIO=(int)(27),
	MAPISTORE_COMMAND_NOTIF_SOCKET_REGISTER_PRIO=(int)(28),
	MAPISTORE_COMMAND_NOTIF_SOCKET_UNREGISTER_PRIO=(int)(29),
	MAPISTORE_COMMAND_USER_REGISTER_PRIO=(int)(30),
	MAPISTORE_COMMAND_USER_UNREGISTER_PRIO=(int)(31)
}
#else
 { __donnot_use_enum_mapistore_mgmt_command_priority=0x7FFFFFFF}
#define MAPISTORE_COMMAND_NOTIF_REGISTER_PRIO ( 26 )
#define MAPISTORE_COMMAND_NOTIF_UNREGISTER_PRIO ( 27 )
#define MAPISTORE_COMMAND_NOTIF_SOCKET_REGISTER_PRIO ( 28 )
#define MAPISTORE_COMMAND_NOTIF_SOCKET_UNREGISTER_PRIO ( 29 )
#define MAPISTORE_COMMAND_USER_REGISTER_PRIO ( 30 )
#define MAPISTORE_COMMAND_USER_UNREGISTER_PRIO ( 31 )
#endif
;

enum mapistore_mgmt_status
#ifndef USE_UINT_ENUMS
 {
	MAPISTORE_MGMT_SEND=(int)(0x0),
	MAPISTORE_MGMT_REGISTER=(int)(0x1),
	MAPISTORE_MGMT_UNREGISTER=(int)(0x2)
}
#else
 { __donnot_use_enum_mapistore_mgmt_status=0x7FFFFFFF}
#define MAPISTORE_MGMT_SEND ( 0x0 )
#define MAPISTORE_MGMT_REGISTER ( 0x1 )
#define MAPISTORE_MGMT_UNREGISTER ( 0x2 )
#endif
;

struct mapistore_mgmt_user_cmd {
	enum mapistore_mgmt_status status;
	const char *backend;/* [unique,charset(UTF16)] */
	const char *username;/* [unique,charset(UTF16)] */
	const char *vuser;/* [unique,charset(UTF16)] */
}/* [public] */;

struct mapistore_mgmt_bind_cmd {
	const char *username;/* [unique,charset(UTF16)] */
	uint16_t cbContext;
	uint8_t *rgbContext;/* [size_is(cbContext)] */
	uint16_t cbCallbackAddress;
	uint8_t *rgbCallbackAddress;/* [size_is(cbCallbackAddress)] */
}/* [public] */;

/* bitmap mapistore_mgmt_notification_type */
#define mgmt_notification_type_newmail ( 0x2 )
#define mgmt_notification_type_objectcreated ( 0x4 )
#define mgmt_notification_type_objectmodified ( 0x10 )
#define mgmt_notification_type_Tbit ( 0x1000 )
#define mgmt_notification_type_Ubit ( 0x2000 )
#define mgmt_notification_type_Mbit ( 0x8000 )

struct mapistore_mgmt_notification_cmd {
	enum mapistore_mgmt_status status;
	uint16_t NotificationFlags;
	const char *username;/* [unique,charset(UTF16)] */
	uint8_t WholeStore;
	uint64_t FolderID;
	uint64_t MessageID;
	const char *MAPIStoreURI;/* [unique,charset(UTF16)] */
	uint32_t TotalNumberOfMessages;
	uint32_t UnreadNumberOfMessages;
}/* [public] */;

enum mapistore_mgmt_command_type
#ifndef USE_UINT_ENUMS
 {
	MAPISTORE_MGMT_USER=(int)(0x1),
	MAPISTORE_MGMT_BIND=(int)(0x2),
	MAPISTORE_MGMT_NOTIF=(int)(0x3)
}
#else
 { __donnot_use_enum_mapistore_mgmt_command_type=0x7FFFFFFF}
#define MAPISTORE_MGMT_USER ( 0x1 )
#define MAPISTORE_MGMT_BIND ( 0x2 )
#define MAPISTORE_MGMT_NOTIF ( 0x3 )
#endif
;

union mapistore_mgmt_commands {
	struct mapistore_mgmt_user_cmd user;/* [case(MAPISTORE_MGMT_USER)] */
	struct mapistore_mgmt_bind_cmd bind;/* [case(MAPISTORE_MGMT_BIND)] */
	struct mapistore_mgmt_notification_cmd notification;/* [case(MAPISTORE_MGMT_NOTIF)] */
}/* [public,switch_type(uint16)] */;

struct mapistore_mgmt_command {
	enum mapistore_mgmt_command_type type;
	union mapistore_mgmt_commands command;/* [switch_is(type)] */
}/* [public] */;

#endif /* _HEADER_mapistore_mgmt */
#endif /* _PIDL_HEADER_mapistore_mgmt */
